# here we will generate random polynomials for solving the system.

numvars:=vectdim(vars);

# degree is a vector of length numvars+1, with the respectively
# degrees of the polynomials p0, p1, p2 loaded in initialize


#extending the vector deg:

deg:=[seq(deg[i],i=1..numvars+1),0];



deg[vectdim(deg)]:=sum(deg[k]-1,k=1..vectdim(deg)-1)+1;


P:=[seq(0,i=1..numvars+2)];


for i from 1 to numvars+2 do
  P[i]:=randpoly(vars,degree=deg[i]);
od;

P:=evalf(coeffactor*P);


