# This is the main maple routine in which all 
# the corresponding routines are called
# and all the important files are loaded


# Dont forget too change the currentdir,
# currentdir("home/raf/maple/MultiInt/MultiProg4");


#################################################################
#								#
#								#
#		PROBLEM INITIALIZATION				#
#								#
#								#
#################################################################

#################################################################
#								#
#  LOAD INITIAL VALUES IN FILE: INITIALIZELOOP.MPL 		#
#								#
#################################################################

# The file initialize loop is a file constructed to contain a lot
# of information for different sets of examples.

read "initializeloop.mpl";
fremove(datafile);


# Start with loading Maple initializations
# The packages, procedures
read "MapleInitialization.mpl":




# # # #  # # # # # START LOOP EXAMPLES # #  # # # # # # # # # 

for loop from 1 to vectdim(varsloop) do

        print("*" );
	print("*" );
        print("###############","EXAMPLE", loop, "###############"); 
	print("*" );
      
        time0:=time();
	read "initialize.mpl";
        

	#################################################################
	#this part starts with the solving of the system		#
	#################################################################

	# generate the problem (important values loaded in initialize)
        read "GenerateEx.mpl":;
        
	time1:=time();


	for IPloop from 1 to vectdim(ChoiceIPinloop) do

		ChoiceIP:=ChoiceIPinloop[IPloop];
	        print("###############","Interpolationpoints", ChoiceIP, "##############"); 		

		# Initialize all the variables, 
		# for solving the problem
		read "ProblemIni.mpl";
		time2:=time();
                 
               
		# solve the multivariate problem
		 SOL,B,cB,resB,timeupdate,ct:=Solve(vars,numvars,nB,P,IP,numip,ssdeg,residual,omitres,verbose):;
		time3:=time();
               
		# calculate the residual information
	        read "calcres.mpl"; 
                print("kind of IPpoints:",ChoiceIP,"with", numvars, "variables","gives residual",ressphere);
		
		# print output information
                if verbose>-2 then 
		  read "printout.mpl";
		fi;                

		# write data to file
		read "writedata.mpl";



	od;

od;

# # # # # # # # #  # # # # END LOOPEXAMPLES # # # # # # # # # # #  

fclose(datafile);


