####################################################################
# For constructing the identity matrix                             #
####################################################################


Krok := l -> if l[1]=l[2] then 1 else 0 fi:



		
####################################################################
#     Construct residual matrix B                                  #
####################################################################

constructresB:= proc(vars,numvars,IP,cB,P)
	local i, j, k, cIP, resB;
	
        
	# initializing some vars
	cIP:=vectdim(IP);
	resB:=matrix(cIP,cB,[seq([seq(0,j=1..cB)],i=1..cIP)]);


	for i from 1 to cIP do
 	  for j from 1 to cB do
	    resB[i,j]:=P[j];
	      for k from 1 to numvars do
  		resB[i,j]:=subs(vars[k]=IP[i][k], resB[i,j]);
	      od;
	  od;
	od;

	RETURN(resB);
end:
