# here we will calculate
# a good measure which we can use as residual measure.

# The points we will generate here, will ly on the n-dimensional
# unit sphere. and within these points we will search for the maximum value.

# first of all we have to generate arbitrary points on the unit spheres:
# remark that rhis test only can be performed for
# numvars>1  and numvars <12 (this latter inequality can be changed)

if numvars>1 and numvars<12 then

  # initialize here the number of test points:
  numpoints:=numvars*100;


  s:=[s0,s1,s2,s3,s4,s5,s6,s7,s8,s9,s10];
  sphere:=[1];
  for i from 1 to (numvars-1) do
    sphere:=[seq(sin(s[i])*sphere[j],j=1..vectdim(sphere)),cos(s[i])];
  od;
  
  # sphere is no an numvars dimensional array
  # which for numvars-1 parameters generates points on
  # the unit sphere.

  # gen will generate numbers within the range -2Pi .. 2Pi
  gen:=evalf(rand(-62800..62800)/10000);
  
  testpoints:=array(1..numpoints,[]);  

  for j from 1 to numpoints do
    testpoints[j]:=evalf(subs(seq(s[i]=gen(),i=1..numvars-1),sphere));
  od;
  
  #TTT:=0;
  #print(testpoints[1]);
  #for i from 1 to numvars do
  # TTT:=testpoints[20][i]^2+TTT;
  #od;
  #print(TTT);


  # hier zoeken we het maximum van de p_i()g_i() geevalueerd
  # in de hier berekende punten
  # the matrix GP, contains in the rows the different interpolationpoints,
  # and in the columns the different produkts GP

  GP:=matrix(numpoints,numvars+2,[seq([seq(0,i=1..numvars+2)],j=1..numpoints)]);
  
  for j from 1 to numpoints do
    for i from 1 to numvars+2 do
     GP[j,i]:=evalf(subs(seq(vars[k]=testpoints[j][k],k=1..numvars),P[i]*SOL[i]))   
    od;
  od; 

 

  # unassign some variables which are not needed anymore
  
  unassign('sphere');

  

  GPmax:=vector(numpoints,[seq(0,k=1..numpoints)]);
  GPres:=vector(numpoints,[seq(0,k=1..numpoints)]);
  
  for j from 1 to numpoints do
   GPmax[j]:=max(seq(abs(GP[j,k]),k=1..numvars+2));
   GPres[j]:=evalf(subs(seq(vars[k]=testpoints[j][k],k=1..numvars),innerprod(P,SOL)));
  od;
  

  ressphere:=max(seq(abs(GPres[k])/GPmax[k],k=1..numvars+2 ));
 
  unassign('GPmax');
  unassign('GPres');

  else
  
  # we do not give a calculation for residuals in this case
  ressphere:=1234567;
  # this strange number will draw the programmers attention


fi;