# This file loads packages
# and some important Maple topics


# Load packages
with(linalg):;
with(combinat):;

# read Krok, and CalculateResidual procedures
read "OtherProcs.mpl";

# load the procedure for one iterationstep
read "OneIntStepFast.mpl";

# load the main program, starting the loop
read "Program.mpl":;

# load the degree tester of a matrix
read "Deg.mpl":;

# load the simplifier of matrix B
read "cleanupB.mpl";

