# in this file we will delete all the information not needed
# anymore in the matrix B , we only delete the columns, higher then nB
# this makes no difference

cleanupB:= proc(B,resB,sdeg,cB,omitres,residual,numip)

	local i, j,Q,mxB,mxR,colB,sdegtemp;

        colB:=cB;
	j:=nB+1;        
        sdegtemp:=sdeg;
	while j<=colB do
          Q:=[seq(coeffs(B[i,j]),i=1..rowdim(B))];
          mxB:=max(seq(abs(Q[i]),i=1..vectdim(Q)));
          mxR:=max(seq(abs(resB[i,j]),i=1..numip));
	  unassign('Q');
          if (mxB < omitres) then
            if verbose > 0 then
              print("delete column",j,"because almost zero,max coefficient: ",mxB);
            fi;
            # delete this column out of B and out of resB.   
	    sdegtemp:=[seq(sdegtemp[i],i=[seq(k,k=1..j-1),seq(k,k=j+1..colB)])];
	    B:=delcols(B,j..j);
	    resB:=delcols(resB,j..j);
            colB:=colB-1;
          elif (mxR<residual) then
            if verbose > 0 then
              print("Incorporate column ",j," in solution module");
	      print("with maximum residual",mxR);
              if verbose = 2 then
		print("Column",col(B,j));
              fi; 
            fi;
            sdegtemp:=[seq(sdegtemp[i],i=[seq(k,k=1..j-1),seq(k,k=j+1..colB)])];
	    B:=delcols(B,j..j);
             resB:=delcols(resB,j..j);
            colB:=colB-1;
          else
            j:=j+1;  
          fi;
	od;
	RETURN(matrix(B),colB,resB,evalm(sdegtemp));
end;